"use strict";
exports.__esModule = true;
exports.parseAsReadonlyArray = exports.parseAsArray = void 0;
var parser_1 = require("../parser");
var util_1 = require("../util");
var util_2 = require("./util");
var getActualType = function (u) {
    return Array.isArray(u) ? 'array' : (0, util_1.getPossibleSelfDefinedType)(u);
};
var parseAsAnArray = function (map, u, isImmutable) {
    return (0, parser_1.createDataStructureParser)({
        expectedType: 'array',
        actualType: getActualType(u),
        t: function () { return (0, util_2.freeze)(function () { return u.map(map); }, isImmutable); }
    });
};
var parseAsArray = function (u, map) {
    return parseAsAnArray(map, u, false);
};
exports.parseAsArray = parseAsArray;
var parseAsReadonlyArray = function (u, map) {
    return parseAsAnArray(map, u, true);
};
exports.parseAsReadonlyArray = parseAsReadonlyArray;
//# sourceMappingURL=array.js.map