import { ParameterlessLazyLoad } from '../types';
declare type Options<T> = Readonly<{
    elseGet: <U>(u: U) => U | T;
    elseLazyGet: <A>(u: () => A) => A | T;
    elseThrow: (message: string) => T;
}>;
declare type OptionsParameter<T> = Readonly<{
    t: ParameterlessLazyLoad<T>;
    isMatchingType: ParameterlessLazyLoad<boolean>;
}>;
declare const createOptions: <T>({ t, isMatchingType, }: Readonly<{
    t: ParameterlessLazyLoad<T>;
    isMatchingType: ParameterlessLazyLoad<boolean>;
}>) => Readonly<{
    elseGet: <U>(u: U) => T | U;
    elseLazyGet: <A>(u: () => A) => T | A;
    elseThrow: (message: string) => T;
}>;
declare const createExact: <T, E extends T>({ t, e, }: Readonly<{
    t: unknown;
    e: E;
}>) => Readonly<{
    elseGet: <U>(u: U) => E | U;
    elseLazyGet: <A>(u: () => A) => E | A;
    elseThrow: (message: string) => E;
}>;
export { Options, OptionsParameter };
export { createOptions, createExact };
