declare type ObjectParams<T> = Readonly<{
    u: unknown;
    t: (u: any) => T;
}>;
declare const parseAsObject: <T extends Object>(u: unknown, t: (u: any) => T) => Readonly<{
    elseGet: <U>(u: U) => T | U;
    elseLazyGet: <A>(u: () => A) => T | A;
    elseThrow: (message: string) => T;
}>;
declare const parseAsReadonlyObject: <T extends Object>(u: unknown, t: (u: any) => T) => Readonly<{
    elseGet: <U>(u: U) => Readonly<T> | U;
    elseLazyGet: <A>(u: () => A) => Readonly<T> | A;
    elseThrow: (message: string) => Readonly<T>;
}>;
export { parseAsObject, parseAsReadonlyObject };
