import { PossibleSelfDefinedType, ParameterlessLazyLoad } from '../types';
declare type Params<T> = Readonly<{
    t: T;
    expectedType: PossibleSelfDefinedType;
}>;
declare const createPrimitiveParser: <T>({ t, isMatchingType, }: Readonly<{
    t: unknown;
    expectedType: PossibleSelfDefinedType;
}> & Readonly<{
    isMatchingType: () => boolean;
}>) => Readonly<{
    elseGet: <U>(u: U) => T | U;
    elseLazyGet: <A>(u: () => A) => T | A;
    elseThrow: (message: string) => T;
}>;
declare const createDataStructureParser: <T>({ t, expectedType, actualType, }: Readonly<{
    t: ParameterlessLazyLoad<T>;
    expectedType: PossibleSelfDefinedType;
}> & Readonly<{
    expectedType: PossibleSelfDefinedType;
}> & Readonly<{
    actualType: PossibleSelfDefinedType;
}>) => Readonly<{
    elseGet: <U>(u: U) => T | U;
    elseLazyGet: <A>(u: () => A) => T | A;
    elseThrow: (message: string) => T;
}>;
export { createPrimitiveParser, createDataStructureParser };
