import { createDataStructureParser } from '../parser.js';
import { getPossibleSelfDefinedType } from '../util.js';
import { freeze } from './util.js';
const getActualType = (u) => Array.isArray(u) ? 'array' : getPossibleSelfDefinedType(u);
const parseAsAnArray = (map, u, isImmutable) => createDataStructureParser({
    expectedType: 'array',
    actualType: getActualType(u),
    t: () => freeze(() => u.map(map), isImmutable),
});
const parseAsArray = (u, map) => parseAsAnArray(map, u, false);
const parseAsReadonlyArray = (u, map) => parseAsAnArray(map, u, true);
export { parseAsArray, parseAsReadonlyArray };
//# sourceMappingURL=array.js.map